Index: CMT/v1r25-branch/source/cmt_commands.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_commands.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_commands.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -256,4 +257,10 @@
   pv.push_back (&ArgParser::option_no_cleanup); i++;
 
+  parsers.add ("-no_strip_p", i);
+  parsers.add ("-no_strip_pa", i);
+  parsers.add ("-no_strip_pat", i);
+  parsers.add ("-no_strip_path", i);
+  pv.push_back (&ArgParser::option_no_strip_path); i++;
+
   parsers.add ("-pac", i);
   parsers.add ("-pack", i);
@@ -263,4 +270,10 @@
   parsers.add ("-path", i);
   pv.push_back (&ArgParser::option_path); i++;
+
+  parsers.add ("-strip_p", i);
+  parsers.add ("-strip_pa", i);
+  parsers.add ("-strip_pat", i);
+  parsers.add ("-strip_path", i);
+  pv.push_back (&ArgParser::option_strip_path); i++;
 
   parsers.add ("-pr", i);
@@ -346,4 +359,24 @@
   parsers.add ("-without_cmt", i);
   pv.push_back (&ArgParser::option_without_cmt); i++;
+
+  parsers.add ("-with_p", i);
+  parsers.add ("-with_pr", i);
+  parsers.add ("-with_pro", i);
+  parsers.add ("-with_proj", i);
+  parsers.add ("-with_proje", i);
+  parsers.add ("-with_projec", i);
+  parsers.add ("-with_project", i);
+  parsers.add ("-with_projects", i);
+  pv.push_back (&ArgParser::option_with_projects); i++;
+
+  parsers.add ("-without_p", i);
+  parsers.add ("-without_pr", i);
+  parsers.add ("-without_pro", i);
+  parsers.add ("-without_proj", i);
+  parsers.add ("-without_proje", i);
+  parsers.add ("-without_projec", i);
+  parsers.add ("-without_project", i);
+  parsers.add ("-without_projects", i);
+  pv.push_back (&ArgParser::option_without_projects); i++;
 
   parsers.add ("-warn", i);
@@ -1903,6 +1936,8 @@
 {
   cmt.m_disable_warnings = true;
-  if (CmtMessage::level () <= Warning)
-    CmtMessage::set_level (Error);
+//   if (CmtMessage::level () <= Warning)
+//     CmtMessage::set_level (Error);
+  if (!Cmt::add_cmt_flag ("-disable_warnings"))
+    CmtError::set (CmtError::system_error, "Cannot add flag `-disable_warnings'");
 }
 
@@ -1910,6 +1945,8 @@
 {
   cmt.m_quiet = true;
-  if (CmtMessage::level () <= Error)
-    CmtMessage::set_level (Fatal);
+//   if (CmtMessage::level () <= Error)
+//     CmtMessage::set_level (Fatal);
+  if (!Cmt::add_cmt_flag ("-quiet"))
+    CmtError::set (CmtError::system_error, "Cannot add flag `-quiet'");
 }
 
@@ -1918,6 +1955,8 @@
 {
   cmt.m_warnings = true;
-  if (CmtMessage::level () != Warning)
-    CmtMessage::set_level (Warning);
+//   if (CmtMessage::level () != Warning)
+//     CmtMessage::set_level (Warning);
+  if (!Cmt::add_cmt_flag ("-warnings"))
+    CmtError::set (CmtError::system_error, "Cannot add flag `-warnings'");
 }
 
@@ -1952,35 +1991,15 @@
     {
       CmtSystem::cmt_string_vector words;
-
       CmtSystem::split (arg, ":", words);
 
       cmt.m_current_access = UserMode;
+
+      cmt.m_current_package = "";
+      cmt.m_current_version = "";
+      cmt.m_current_path = "";
 
       if (words.size () > 0) cmt.m_current_package = words[0];
       if (words.size () > 1) cmt.m_current_version = words[1];
       if (words.size () > 2) cmt.m_current_path    = words[2];
-      (Use::current()).set (cmt.m_current_package, 
-			    cmt.m_current_version, 
-			    cmt.m_current_path);
-
-      Use& use = Use::current();
-      if (use.get_package_name () == "cmt_standalone")
-	{
-          if (!CmtSystem::cd (use.path) || !CmtSystem::test_file ("requirements"))
-            {
-	      CmtError::set (CmtError::package_not_found, use.get_info ());
-	      return;
-	    }
-	  use.style = none_style;
-	  use.structuring_style = without_version_directory;
-	  use.change_path (CmtSystem::pwd ());
-	}
-      else if (!use.move_to ("", true))
-	{
-	  CmtError::set (CmtError::package_not_found, use.get_info ());
-	  return;
-	}
-      Project::order_all ();
-      Cmt::guess_current_project ();
     }
 }
@@ -1995,16 +2014,6 @@
 
       cmt.m_current_package = arg;
-      cmt.m_current_version = "";
-
-      /*
-      cerr << "ArgParser::option_pack> "
-	   << " cp=" << cmt.m_current_package
-	   << " cv=" << cmt.m_current_version
-	   << " cp=" << cmt.m_current_path << endl;
-      */
-
-      (Use::current()).set (cmt.m_current_package, 
-			    cmt.m_current_version, 
-			    cmt.m_current_path);
+      //      cmt.m_current_version = "";
+
     }
 }
@@ -2016,15 +2025,4 @@
       cmt.m_current_access = UserMode;
       cmt.m_current_version = arg;
-
-      /*
-      cerr << "ArgParser::option_version> "
-	   << " cp=" << cmt.m_current_package
-	   << " cv=" << cmt.m_current_version
-	   << " cp=" << cmt.m_current_path << endl;
-      */
-
-      (Use::current()).set (cmt.m_current_package, 
-			    cmt.m_current_version, 
-			    cmt.m_current_path);
     }
 }
@@ -2036,37 +2034,4 @@
       cmt.m_current_access = UserMode;
       cmt.m_current_path = arg;
-
-      /*
-      cerr << "ArgParser::option_path> "
-	   << " cp=" << cmt.m_current_package
-	   << " cv=" << cmt.m_current_version
-	   << " cp=" << cmt.m_current_path << endl;
-      */
-
-      (Use::current()).set (cmt.m_current_package, 
-			    cmt.m_current_version, 
-			    cmt.m_current_path);
-
-      //IProjectFactory& factory = ProjectFactory::instance ();
-      //CmtSystem::add_cmt_path (cmt.m_current_path, "argument", factory);
-      Use& use = Use::current();
-      if (use.get_package_name () == "cmt_standalone")
-	{
-          if (!CmtSystem::cd (use.path) || !CmtSystem::test_file ("requirements"))
-            {
-	      CmtError::set (CmtError::package_not_found, use.get_info ());
-	      return;
-	    }
-	  use.style = none_style;
-	  use.structuring_style = without_version_directory;
-	  use.change_path (CmtSystem::pwd ());
-	}
-      else if (!use.move_to ("", true))
-	{
-	  CmtError::set (CmtError::package_not_found, use.get_info ());
-	  return;
-	}
-      Project::order_all ();
-      Cmt::guess_current_project ();
     }
 }
@@ -2079,5 +2044,4 @@
 void ArgParser::option_e ()
 {
-  //CmtMessage::warning ("extra statement = " + arg);
   extra_line = arg;
 }
@@ -2089,4 +2053,18 @@
       cmt.m_cmt_home = arg;
     }
+}
+
+void ArgParser::option_no_strip_path ()
+{
+  cmt.m_strip_path = false;
+  if (!Cmt::add_cmt_flag ("-no_strip_path"))
+    CmtMessage::error ("Cannot add flag `-no_strip_path'");
+}
+
+void ArgParser::option_strip_path ()
+{
+  cmt.m_strip_path = true;
+  if (!Cmt::add_cmt_flag ("-strip_path"))
+    CmtMessage::error ("Cannot add flag `-strip_path'");
 }
 
@@ -2098,4 +2076,30 @@
   if (arg != "")
     {
+      cmt.m_tags.clear ();
+      CmtSystem::cmt_string_vector words;
+      CmtSystem::split (arg, " \t,", words);
+      for (int i = 0; i < words.size (); i++)
+	{
+	  bool has (false);
+	  for (int j = 0; j < cmt.m_tags.size (); j++)
+	    {
+	      if (cmt.m_tags[j] == words[i])
+		{
+		  has = true;
+		  break;
+		}
+	    }
+	  if (!has)
+	    cmt.m_tags.push_back (words[i]);
+	}
+
+      if (cmt.m_tags.size () != 0)
+	{
+	  cmt.m_extra_tags.clear ();
+	  cmt.m_tags_add.clear ();
+	  cmt.m_tags_remove.clear ();
+	}
+
+      /*
       Tag* tag;
       CmtSystem::cmt_string_vector words;
@@ -2151,4 +2155,5 @@
 	// To be sure that a tag
 	Cmt::guess_current_project ();
+      */
     }
 }
@@ -2156,4 +2161,32 @@
 void ArgParser::option_tag_add ()
 {
+  CmtSystem::cmt_string_vector words;
+  CmtSystem::split (arg, " \t,", words);
+  for (int i = 0; i < words.size (); i++)
+    {
+      bool has (false);
+      for (int j = 0; j < cmt.m_tags_add.size (); j++)
+	{
+	  if (cmt.m_tags_add[j] == words[i])
+	    {
+	      has = true;
+	      break;
+	    }
+	}
+      if (!has)
+	{
+	  cmt.m_tags_add.push_back (words[i]);
+	}
+      
+      for (int j = 0; j < cmt.m_tags_remove.size (); j++)
+	{
+	  if (cmt.m_tags_remove[j] == words[i])
+	    {
+	      cmt.m_tags_remove.erase(j);
+	      break;
+	    }
+	}
+    }
+  /*
   Tag* tag;
   CmtSystem::cmt_string_vector words;
@@ -2188,23 +2221,56 @@
 	}
     }
+  */
 }
 
 void ArgParser::option_tag_remove ()
 {
+  CmtSystem::cmt_string_vector words;
+  CmtSystem::split (arg, " \t,", words);
+  for (int i = 0; i < words.size (); i++)
+    {
+      bool has (false);
+      for (int j = 0; j < cmt.m_tags_remove.size (); j++)
+	{
+	  if (cmt.m_tags_remove[j] == words[i])
+	    {
+	      has = true;
+	      break;
+	    }
+	}
+      if (!has)
+	{
+	  cmt.m_tags_remove.push_back (words[i]);
+	}
+
+      for (int j = 0; j < cmt.m_extra_tags.size (); j++)
+	{
+	  if (cmt.m_extra_tags[j] == words[i])
+	    {
+	      cmt.m_extra_tags.erase(j);
+	      break;
+	    }
+	}
+      for (int j = 0; j < cmt.m_tags.size (); j++)
+	{
+	  if (cmt.m_tags[j] == words[i])
+	    {
+	      cmt.m_tags.erase(j);
+	      break;
+	    }
+	}
+      for (int j = 0; j < cmt.m_tags_add.size (); j++)
+	{
+	  if (cmt.m_tags_add[j] == words[i])
+	    {
+	      cmt.m_tags_add.erase(j);
+	      break;
+	    }
+	}
+    }
+  /*
   Tag::TagPtrVector tags = Tag::tags ();
   int i;
   Tag* tag;
-
-  /*
-    for (i = 0; i < tags.size (); i++)
-    {
-    tag = tags[i];
-    if ((tag != 0) &&
-    (tag->selected))
-    {
-    if (!cmt.m_quiet) cerr << "  original tag_list=" << tag->name << tag->priority << endl;
-    }
-    }
-  */
 
   CmtSystem::cmt_string_vector words;
@@ -2259,6 +2325,4 @@
 	    const cmt_string& a = words[i];
 
-	    //fprintf (stderr, "  a=[%s]\n", a.c_str ());
-
 	    /// Then restore uname if the specified tag is CMTCONFIG
 	      if (a == CmtSystem::get_cmt_config ())
@@ -2283,4 +2347,5 @@
 	      tag->mark ("arguments");
 	  }
+  */
 }
 
@@ -2307,14 +2372,25 @@
 }
 
+void ArgParser::option_with_projects ()
+{
+  cmt.m_use_projects = true;
+  if (!Cmt::add_cmt_flag ("-with_projects"))
+    CmtMessage::error ("Cannot add flag `-with_projects'");
+}
+
+void ArgParser::option_without_projects ()
+{
+  cmt.m_use_projects = false;
+  if (!Cmt::add_cmt_flag ("-without_projects"))
+    CmtMessage::error ("Cannot add flag `-without_projects'");
+}
+
 void ArgParser::option_with_version_directory ()
 {
   cmt.m_current_structuring_style = with_version_directory;
 
-  StrategyDef* def = StrategyMgr::find_strategy ("VersionDirectory");
-  if (def != 0)
-    {
-      def->m_default_value = true;
-      def->m_priority_value = false;
-    }
+  if (!Cmt::add_cmt_flag ("-with_version_directory"))
+    CmtError::set (CmtError::system_error, "Cannot add flag `-with_version_directory'");
+
 }
 
@@ -2323,10 +2399,7 @@
   cmt.m_current_structuring_style = without_version_directory;
 
-  StrategyDef* def = StrategyMgr::find_strategy ("VersionDirectory");
-  if (def != 0)
-    {
-      def->m_default_value = false;
-      def->m_priority_value = true;
-    }
+  if (!Cmt::add_cmt_flag ("-without_version_directory"))
+    CmtError::set (CmtError::system_error, "Cannot add flag `-without_version_directory'");
+
 }
 
@@ -2398,5 +2471,5 @@
   cout << "#   -path=<path>            : set root path" << endl;
   cout << "#   -f=<requirements-file>  : set input file" << endl;
-  cout << "#   -e=<statement>          : add a one line statement" << endl;
+  cout << "#   -e=<statement(s)>       : add (multiple) statement(s)" << endl;
   cout << "#   -tag=<tag-list>         : select a new tag-set" << endl;
   cout << "#   -tag_add=<tag-list>     : add specific comma-separated tag(s)" << endl;
@@ -2408,4 +2481,6 @@
   cout << "#   -no_cleanup             : inhibit install area cleanup" << endl;
   cout << "#   -xml                    : output in XML format (cmt setup, cmt show projects, cmt show uses)" << endl;
+  cout << "#   -user_context=<path>    : set user context package/project directory" << endl;
+  cout << "#   -home=<path>            : set home package/project directory" << endl;
 }
 
Index: CMT/v1r25-branch/source/cmt_commands.h
===================================================================
--- CMT/v1r25-branch/source/cmt_commands.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_commands.h	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -83,7 +84,11 @@
   void option_with_cmt ();
   void option_without_cmt ();
+  void option_with_projects ();
+  void option_without_projects ();
   void option_with_version_directory ();
   void option_without_version_directory ();
   void option_no_cleanup ();
+  void option_no_strip_path ();
+  void option_strip_path ();
   void option_private ();
   void option_public ();
Index: CMT/v1r25-branch/source/cmt_constituent.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_constituent.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_constituent.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_constituent.h
===================================================================
--- CMT/v1r25-branch/source/cmt_constituent.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_constituent.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_cvs.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_cvs.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_cvs.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by: garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_database.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_database.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_database.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_database.h
===================================================================
--- CMT/v1r25-branch/source/cmt_database.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_database.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_deps_builder.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_deps_builder.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_deps_builder.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -226,9 +227,12 @@
         }
     }
-  else if (!strncmp (ptr, "      include", 13))
+  else if (!strncmp (ptr, "include", 7) ||
+	   !strncmp (ptr, "INCLUDE", 7))
+  //  else if (!strncmp (ptr, "      include", 13))
     {
       // fortran include statement
 
-      ptr += 13;
+      ptr += 7;
+      //ptr += 13;
 
       while ((*ptr == ' ') || (*ptr == '\t')) ptr++;
@@ -239,4 +243,9 @@
           ptr++;
         }
+      else if (*ptr == '(')
+	{
+	  term = ')';
+	  ptr++;
+	}
       else
         {
@@ -245,4 +254,5 @@
         }
     }
+  /*
   else if (!strncmp (ptr, "\tinclude", 8))
     {
@@ -264,4 +274,5 @@
         }
     }
+  */
   else
     {
@@ -308,6 +319,6 @@
 static char* in_line_action (char* ptr, state_def& state)
 {
-  char* pattern = ptr + strlen (ptr);
-  int length = 0;
+  //  char* pattern = ptr + strlen (ptr);\
+  //  int length = 0;
 
   /*
@@ -318,4 +329,48 @@
   */
 
+  char* beg = ptr;
+  while (char* p = strpbrk (beg, "\"\'/"))
+    if (*p == '"')
+      {
+	if (p == ptr || (p > ptr && *(p - 1) != '\\'))
+	  {
+	    state = in_string;
+	    return p + 1;
+	  }
+	else
+	  { // '"' is escaped
+	    beg = p + 1;
+	  }
+      }
+    else if (*p == '\'')
+      {
+	if (p == ptr || (p > ptr && *(p - 1) != '\\'))
+	  {
+	    state = in_char;
+	    return p + 1;
+	  }
+	else
+	  { // '\'' is escaped
+	    beg = p + 1;
+	  }
+      }
+    else
+      { // we have '/'
+	if (*(p + 1) == '*')
+	  {
+	    state = in_comment;
+	    return p + 2;
+	  }
+	else if (*(p + 1) == '/')
+	  {
+	    state = in_line_comment;
+	    return p + 2;
+	  }
+	else
+	  {
+	    beg = p + 1;
+	  }
+      }
+  /*
   char* pos = strchr (ptr, '"');
   if ((pos != 0) && (pos < pattern) && (pos > ptr) && (*(pos-1) != '\\'))
@@ -334,5 +389,5 @@
     }
 
-  pos = strstr (ptr, "/*");   //*/
+  pos = strstr (ptr, "/*");
   if ((pos != 0) && (pos < pattern))
     {
@@ -351,6 +406,7 @@
 
   ptr = pattern + length;
-
   return (ptr);
+*/
+  return  ptr + strlen (ptr);
 }
 
@@ -650,5 +706,12 @@
 	} // while (strlen (ptr) > 0)
       
-      if (state == in_line) state = at_start;
+      //if (state == in_line) state = at_start;
+      switch (state)
+	{
+	case in_line:
+	case in_line_comment:
+	  state = at_start;
+	  break;
+	}
       line_number++;
 
Index: CMT/v1r25-branch/source/cmt_deps_builder.h
===================================================================
--- CMT/v1r25-branch/source/cmt_deps_builder.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_deps_builder.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_error.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_error.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_error.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -18,5 +19,5 @@
   {
     error_names.add() = "ok";
-    error_names.add() = "Warning";
+    error_names.add() = "warning";
     error_names.add() = "symbol not found";
     error_names.add() = "pattern not found";
@@ -159,5 +160,5 @@
 
   result = get_error_name (e.get_code ());
-  result += " : ";
+  result += ": ";
   result += e.get_text ();
 
Index: CMT/v1r25-branch/source/cmt_error.h
===================================================================
--- CMT/v1r25-branch/source/cmt_error.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_error.h	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_fragment.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_fragment.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_fragment.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_fragment.h
===================================================================
--- CMT/v1r25-branch/source/cmt_fragment.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_fragment.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_generator.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_generator.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_generator.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_generator.h
===================================================================
--- CMT/v1r25-branch/source/cmt_generator.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_generator.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_generators.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_generators.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_generators.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -2809,4 +2810,5 @@
   m_PACKAGEFULLNAME.set ("PACKAGEFULLNAME");
   m_ISLOCAL.set ("ISLOCAL");
+  m_ISINCLUDED.set ("ISINCLUDED");
 
   packages_header_fragment.set ("packages_header");
@@ -2822,4 +2824,5 @@
   m_PACKAGEFULLNAME = "";
   m_ISLOCAL = "";
+  m_ISINCLUDED = "";
 
   packages_header_fragment.reset ();
@@ -2867,11 +2870,16 @@
       if (!packages_header_fragment.copy (m_output_file, 1, &m_PACKAGE)) return;
 
-      Project* cur = Project::get_current ();
+      const Project* p_cur (Project::get_current ());
       Use::UsePtrVector uses (Use::get_ordered_uses ());
       uses.push_back (&Use::current ());
+
+      Project::ConstProjectPtrVector path_exclusions;
+      Project::fill_exclusion (path_exclusions);
+
       cmt_string temp;
       for (int i = uses.size () - 1; i >= 0; i--)
 	{
 	  Use* use = uses[i];
+
 	  if (use->discarded) continue;
 	  if (use->m_hidden) continue;
@@ -2879,8 +2887,48 @@
 	  if (use->get_package ()->is_cmt ()) continue;
 
-	  if (use->get_project () == cur)
-	    m_ISLOCAL = "is_local";
-	  else
-	    m_ISLOCAL = "is_not_local";
+	  const Project* up = use->get_project ();
+
+	  m_ISLOCAL = "is_not_local";
+	  if (p_cur)
+	    {
+	      if (up)
+		{
+		  if (up == p_cur)
+		    {
+		      m_ISLOCAL = "is_local";
+		    }
+		}
+	      else
+		{
+		  if (use->get_realpath ().find (p_cur->get_cmtpath_real ()) == 0)
+		    {
+		      m_ISLOCAL = "is_local";
+		    }
+		}
+	    }
+	  else if (use == &Use::current ())
+	    {
+	      m_ISLOCAL = "is_local";
+	    }
+
+	  m_ISINCLUDED = "is_included";
+          for (int j = 0; j < path_exclusions.size (); j++)
+            {
+              const Project* sp = path_exclusions[j];
+	      if (up)
+		{
+		  if (up == sp)
+		    {
+		      m_ISINCLUDED = "is_not_included";
+		    }
+		}
+	      else
+		{
+		  if (use->get_realpath ().find (sp->get_cmtpath_real ()) == 0)
+		    {
+		      m_ISINCLUDED = "is_not_included";
+		    }
+		}
+            }
 
 	  temp = use->get_full_path ();
@@ -2895,4 +2943,6 @@
 	      temp += "mgr";
 	      break;
+	    default:
+	      break;
 	    }
 #ifdef WIN32
@@ -2900,5 +2950,4 @@
 #endif
 	  m_PACKAGEMGRPATH = temp;
-	  //	  fprintf (m_output_file, "%s\n", temp.c_str());
 
 	  temp = "";
@@ -2924,5 +2973,4 @@
 #endif
 	  m_PACKAGEFULLNAME = temp;
-	  //	  fprintf (m_output_file, "%s\n", temp.c_str());
 
 	  m_PACKAGE = use->get_package_name ();
@@ -2959,9 +3007,9 @@
 	    }
 
-	  if (!package_fragment.copy (m_output_file, 6,
+	  if (!package_fragment.copy (m_output_file, 7,
 				      &m_PACKAGE, &m_PACKAGEPREFIX,
 				      &m_DEPENDENCIES,
 				      &m_PACKAGEMGRPATH, &m_PACKAGEFULLNAME,
-				      &m_ISLOCAL)) return;
+				      &m_ISLOCAL, &m_ISINCLUDED)) return;
 	}
 
@@ -2984,5 +3032,4 @@
 
       CmtSystem::close_ostream (m_output_file, new_file_name);
-      //  fclose (m_output_file);
 
       commit (new_file_name);
Index: CMT/v1r25-branch/source/cmt_generators.h
===================================================================
--- CMT/v1r25-branch/source/cmt_generators.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_generators.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -238,4 +239,5 @@
   Variable m_PACKAGEFULLNAME;
   Variable m_ISLOCAL;
+  Variable m_ISINCLUDED;
 
   FragmentHandle packages_header_fragment;
Index: CMT/v1r25-branch/source/cmt_install_area.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_install_area.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_install_area.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_language.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_language.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_language.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_language.h
===================================================================
--- CMT/v1r25-branch/source/cmt_language.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_language.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_lock.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_lock.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_lock.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_log.h
===================================================================
--- CMT/v1r25-branch/source/cmt_log.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_log.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_map.h
===================================================================
--- CMT/v1r25-branch/source/cmt_map.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_map.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -276,5 +277,6 @@
    *   Return 0 if not found
    */
-  const T* find (const K& key) const
+  T* find (const K& key)
+    //  const T* find (const K& key) const
   {
     if (key < m_key)
@@ -504,5 +506,6 @@
    *   Returns 0 if not found
    */
-  const T* find (const K& key) const
+  T* find (const K& key) const
+    //  const T* find (const K& key) const
   {
     if (m_top != 0)
Index: CMT/v1r25-branch/source/cmt_model.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_model.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_model.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
